
#import "backend.h"
#import "timeconversions.h"

@implementation backend

- displayP
{
	char buf[256];
  	
	if(distance == 0.0)
		paceSecs = 0.0;
	else
		paceSecs = (timeSecs/(distance*distanceUnit))*milesPerSplit;

	to_timestring( (float) paceSecs,buf);
        [paceTime setStringValue: buf];

    return self;
}

- displayT:sender
{
	char buf[256];
  	int  minutes;
        	double  seconds;

minutes =  (int) floor(timeSecs/60.0);         /* store current sliders */
seconds = timeSecs - minutes*60.0;

if ([sender isKindOf: [Slider class]]){  
if ( [sender  tag] == 1)
seconds = [sender doubleValue];   /* see which slider is moved */
else
minutes = [sender intValue];

timeSecs = minutes*60.0 + seconds; /* and recompute target time */

// convert to hh:mm:second.s format for display in cell.

to_timestring( (float) timeSecs,buf);
       //  display formatted time string in targetWindow

[targetWindow setStringValue: buf];
}
else { /* sender must be the target time window */

if(!to_seconds([targetWindow stringValue],buf))
	NXBeep();  /* invalid input: play beep */
timeSecs = atof(buf);
}
// Update pace time
[ self displayP];
		
    return self;
}

- getDistance:sender
{
	
/* round down to tenth so that display is truthful */

        if( sender == distanceSlider ) {
	distance = [ sender doubleValue ]*distanceUnit;	
	distance = floor(distance*10.0)/10.0;
 	specialDistanceFlag = 0;
	}
	else {
	specialDistanceFlag = 3;
	distance = [ sender doubleValue ];
	}
	[ self displayD];
	[self displayP];
    return self;
}
- displayD;
{
	char buf[256];

	if(specialDistanceFlag == 0){
	sprintf( buf, "%7.1f",distance);
	[ distanceWindow setStringValue: buf];
	}
	else if(specialDistanceFlag == 3){
	sprintf( buf, "%8.5f",distance);
	[ distanceWindow setStringValue: buf];
	} else {
	sprintf( buf, "%8.5f",distance);
	[ distanceWindow setStringValue: buf];
	}


	return self;
}
- showInfo:sender
{
	if(infoPanel == nil) {
		if(![NXApp
			loadNibSection: "info.nib"
			owner: self
			withNames: NO]) {
		return nil; /* load failed */
	}
}
	[infoPanel makeKeyAndOrderFront: nil];
	return self;
}
- setUnits:sender;
{
	if ( [[sender selectedCell] tag] == 1)
		distanceUnit = 1.0/K_PER_MILE;
	else 
		distanceUnit = 1.0;

/* redisplay distances in special distance case */

	if(specialDistanceFlag ==1)
		distance = .5*K_PER_MARATHON/(K_PER_MILE*distanceUnit);
	if(specialDistanceFlag ==2)
		distance = K_PER_MARATHON/(K_PER_MILE*distanceUnit);

	[self displayP];
	[self displayD];
	return self;
}

- setSplitDistance:sender;
{
	int tagnum;

	tagnum = [[sender selectedCell] tag];
	switch(tagnum) {
		case 1:
			milesPerSplit = 1.0;
			break;
		case 2:
			milesPerSplit = 1.0/K_PER_MILE;
			break;
		case 3:
			milesPerSplit = 0.25;
			break;
		case 4: 
			milesPerSplit = 0.4/K_PER_MILE;
			break;
		case 5:
			milesPerSplit = 0.125;
			break;
		case 6:
			milesPerSplit = 0.2/K_PER_MILE;
			break;
		}
	[self displayD];
	[self displayP];
	return self;
}
- specialDistance:sender;
{
	
	if([sender tag]==0){
		distance =0.5*K_PER_MARATHON/K_PER_MILE;
		specialDistanceFlag = 1;
	}
	
	if([sender tag] == 1){
		distance =K_PER_MARATHON/K_PER_MILE;
		specialDistanceFlag = 2;
	}
	[self displayD];
	[self displayP];
	return self;
}
	

	
@end

@implementation backend(ApplicationDelegate)

-appDidInit:sender;

{
	
	[self setUnits:distanceMatrix];
	[self setSplitDistance:splitMatrix];
		return self;
}
@end
